

;gen10-   
; FG 1-8   IZL 1-7
;  2-15 ,  2  
; PIC 8 
;    
          list      p=16f84A  ;
          __CONFIG  03FF1H    ;
; - - - - -                    
indf      equ       00h       ;
tmr0      equ       01h       ;
pcl       equ       02h       ;
status    equ       03h       ;
fsr       equ       04h       ;
trisa     equ       85h       ;
porta     equ       05h       ;
trisb     equ       86h       ;
portb     equ       06h       ;
option_reg equ      81h       ;
eedata    equ       08h       ;
eeadr     equ       09h       ;
eecon1    equ       88h       ;
eecon2    equ       89h       ;
intcon    equ       0Bh       ;
CLKS      equ       0Ch       ; 
RIN       equ       0Dh       ; 
TPR       equ       0Eh       ; 
NM2       equ       0Fh       ; 
DL        equ       10h       ;
GR        equ       11h       ; 
OT        equ       12h       ; 
OTS       equ       13h       ; 
TRV       equ       14h       ;  
SV3       equ       15h       ;
CLKTMR    equ       16h       ;  TMR
TP        equ       17h       ; 
FG        equ       18h       ;  
IZL       equ       19h       ; 
DIF       equ       1Ah       ; 
MD        equ       1Bh       ; 
PQ        equ       1Ch       ;  
SV4       equ       1Dh       ;
SV5       equ       1Eh       ;
SV6       equ       1Fh       ;
R0        equ       20h       ;
R1        equ       21h       ;
R2        equ       22h       ;
R3        equ       23h       ;
R4        equ       24h       ;
R5        equ       25h       ;
R6        equ       26h       ;
R7        equ       27h       ;
R8        equ       28h       ;
R9        equ       29h       ;
R10       equ       2Ah       ;
R11       equ       2Bh       ;
R12       equ       2Ch       ;
R13       equ       2Dh       ;
R14       equ       2Eh       ;
R15       equ       2Fh       ;
W         equ       .0        ;
RP0       equ       .5        ;
Z         equ       .2        ;
F         equ       .1        ;
DC        equ       .1        ;
          org       0         ;
          GOTO      START     ;
;- - - - -  
          org       4         ;
          BTFSS     intcon,2  ;
          GOTO      CL2       ;
          INCF      CLKTMR,F  ;
          MOVF      CLKTMR,W  ;
          SUBLW     .50       ;!  2 ( X 50)
          BTFSS     status,Z  ;
          GOTO      CL3       ;
          BCF       status,Z  ;
          CLRF      CLKTMR    ;
          INCF      CLKS,F    ;
          MOVF      CLKS,W    ;
          DECF      W         ;
          SUBWF     IZL,W     ;
          BTFSC     status,Z  ;
          GOTO      CL1       ;
          MOVF      DL,W      ;
          MOVWF     portb     ;
          GOTO      CL3       ;
CL1       BCF       status,Z  ;
          CLRF      CLKS      ;
          MOVLW     .126      ;  
          MOVWF     portb     ; IZL
          BSF       DIF,1     ;  
          CALL      PSL       ; FG  IZL
          CALL      RDE       ; OT  DL
CL3       NOP                 ;
;         COMF      portb,F   ;
          BCF       status,Z  ;
          BCF       intcon,2  ;
          BSF       intcon,7  ;
          MOVF      OT,W      ;
          GOTO      CL4       ;
CL2       BTFSS     intcon,1  ; RB0
          GOTO      CL4       ;
          CALL      RMT       ;
          MOVF      OT,W      ;
          BCF       intcon,1  ;
          BSF       intcon,7  ;
CL4       NOP                 ;
          RETURN              ;
;- - - - - - 
START    CLRWDT               ;
         CLRF      porta      ;
         CLRF      portb      ;
         CLRF      CLKTMR     ;
         CLRF      CLKS       ;
         CLRF      DIF        ;
         MOVLW     .2         ;
         MOVWF     MD         ;
         MOVLW     .17        ;
         MOVWF     GR         ;
         MOVLW     .7         ;
         MOVWF     FG         ;
         MOVLW     .3         ;
         MOVWF     IZL        ;
         MOVLW     .100       ;
         MOVWF     PQ         ;
         MOVLW     1Ah        ;13,0 
         MOVWF     R0         ;OT0
         MOVLW     .68        ;(68)
         MOVWF     R1         ;DL0
         MOVLW     10h        ;19,0 
         MOVWF     R2         ;OT1
         MOVLW     .12        ;(12)
         MOVWF     R3         ;DL1
         MOVLW     0Ch        ;22,0 
         MOVWF     R4         ;OT3
         MOVLW     .0         ;(0)
         MOVWF     R5         ;DL3
         MOVLW     1Dh        ;11,5 
         MOVWF     R6         ;OT4
         MOVLW     .82        ;(82)
         MOVWF     R7         ;DL4
         MOVLW     18h        ;14,5 
         MOVWF     R8         ;OT6
         MOVLW     .56        ;(56)
         MOVWF     R9         ;DL6
         MOVLW     0Eh        ;20,5 
         MOVWF     R10        ;OT7
         MOVLW     .4         ;(4)
         MOVWF     R11        ;DL7
         MOVLW     15h        ;16,0 
         MOVWF     R12        ;OT9
         MOVLW     .38        ;(38)
         MOVWF     R13        ;DL9
         MOVLW     12h        ;17,5 
         MOVWF     R14        ;OT10
         MOVLW     .20        ;(20)
         MOVWF     R15        ;DL10
         MOVLW     .176       ;
         MOVWF     intcon     ; TMR0 , RB0 10110000
         BSF       status,RP0 ;
         MOVLW     .215       ;! .215 11010111
         MOVWF     option_reg ;  1:256    
         MOVLW     .1         ;
         MOVWF     trisb      ;RB1-RB7  , RB0  
         MOVLW     .0         ; 
         MOVWF     trisa      ; 3-4  0-2 
         BCF       status,RP0 ;
         BCF       porta,4    ; 
         BCF       porta,0    ;
         BCF       porta,2    ;
         BSF       porta,1    ;
         CALL      UST        ;
         CALL      GNRS1      ;
; - - - - - 
UST      NOP                  ;
         MOVLW     .0         ;
         MOVWF     DL         ;
         MOVLW     .12        ;45   22
         MOVWF     OT         ;
         MOVWF     OTS        ;
         RETURN               ;
; - - - - - 1
GNRS1    NOP                  ;
         MOVF      DL,W       ;
         MOVWF     portb      ;
         MOVF      OT,W       ;
         MOVWF     OTS        ;
GN2      DECFSZ    OTS,F      ;
         GOTO      $-1        ;
         COMF      portb,F    ;
         MOVWF     OTS        ;
         DECFSZ    OTS,F      ;
         GOTO      $-1        ;
         COMF      portb,F    ;
         MOVWF     OTS        ;
         BTFSS     DIF,1      ;
         GOTO      GN2        ;
         CALL      RINP_      ;
         CALL      SWA2       ;
         BCF       DIF,1      ;
         MOVF      OT,W       ;
         GOTO      GN2        ;
         RETURN               ;
; - - - - -  FG & IZL -
PSL      NOP                  ;
         DECFSZ    FG,F       ;
         GOTO      PS1        ;
         MOVLW     .8         ;
         MOVWF     FG         ;
         GOTO      PS1        ;
PS1      DECFSZ    IZL,F      ;
         GOTO      PS2        ;
         MOVLW     .7         ;
         MOVWF     IZL        ;
PS2      NOP                  ; 
         RETURN               ;
; - - - - -  FG -
RDE      NOP                  ;
         MOVLW     .30        ;
         ADDWF     FG,W       ;
         ADDWF     FG,W       ;
         MOVWF     NM2        ;
         MOVWF     fsr        ;
         MOVF      indf,W     ;
         MOVWF     OT         ;
         MOVWF     OTS        ;
         INCF      NM2,W      ;        
         MOVWF     fsr        ;
         MOVF      indf,W     ;
         MOVWF     DL         ;
         RETURN               ;
; - - - - -  
;RIN/tmr0/TPR, REZ7, REZ9/BDECP_
RINP_     NOP                 ;(NOP) in R12
          BCF       intcon,7  ;
          BSF       status,RP0; 1
          MOVLW     .16       ;00010000
          MOVWF     trisa     ;RA4 
          BCF       status,RP0; 0
          CLRF      RIN       ;
          MOVF      tmr0,W    ;
          MOVWF     TPR       ;
RI1       BCF       status,Z  ;
          MOVF      tmr0,W    ;
          SUBWF     TPR,W     ;
          BTFSC     status,Z  ;
          GOTO      RI1       ;
          MOVF      tmr0,W    ;
          MOVWF     TPR       ;
          INCF      RIN,F     ;-
          BTFSC     RIN,6     ;
          GOTO      RI2       ;  63
          BTFSS     porta,4   ;
          GOTO      RI1       ;
          BSF       status,RP0; 1
          MOVLW     .0        ;00000000
          MOVWF     trisa     ;RA4 
          BCF       status,RP0; 0
          BCF       porta,4   ;  
          GOTO      RI3       ;
RI2       MOVLW     .63       ;(63) 50
          MOVWF     RIN       ;
          BSF       status,RP0; 1
          MOVLW     .0        ;00000000
          MOVWF     trisa     ;RA4 
          BCF       status,RP0; 0
          BCF       porta,4   ;  
RI3       MOVF      RIN,W     ;
          SUBLW     .64       ; 
          MOVWF     RIN       ; 
          BSF       intcon,7  ;
          RETURN              ;
; - - - - -  (RA3) 
SWA2     NOP                  ;
         BTFSS     DIF,0      ;
         GOTO      SA1        ; ()
         MOVLW     .255       ; -1 ()
         ADDWF     RIN,W      ; RIN-1
         BCF       status,0   ;
         SUBWF     GR,W       ;
         BTFSS     status,0   ;
         GOTO      SA2        ;  
         BCF       status,0   ;  
         BSF       porta,3    ;
         BSF       DIF,0      ; /
         GOTO      SA3        ;
SA2      BCF       porta,3    ;
         BCF       DIF,0      ;
         GOTO      SA3        ;
SA1      MOVF      RIN,W      ; ()
         BCF       status,0   ;
         SUBWF     GR,W       ;
         BTFSS     status,0   ;
         GOTO      SA4        ;  
         BCF       status,0   ;  
         BSF       porta,3    ;
         BSF       DIF,0      ;
         GOTO      SA3        ;
SA4      BCF       porta,3    ;
         BCF       DIF,0      ;
         GOTO      SA3        ;
SA3      NOP
         RETURN               ;
; - - - - 
RMT      MOVF      CLKTMR,W   ;
         SUBWF     PQ,W       ;
         BTFSC     status,2   ;
         GOTO      RM6        ;
         MOVF      CLKTMR,W   ;
         DECF      W          ;-
         SUBWF     PQ,W       ;
         BTFSC     status,2   ;
         GOTO      RM6        ;
         BCF       porta,0    ;
         BCF       porta,1    ;
         BCF       porta,2    ;
         INCF      MD,F       ;
         BCF       status,2   ;
         MOVLW     .0         ;
         SUBWF     MD,W       ;
         BTFSC     status,2   ;
         GOTO      RM0        ;
         MOVLW     .1         ;
         SUBWF     MD,W       ;
         BTFSC     status,2   ;
         GOTO      RM1        ;
         MOVLW     .2         ;
         SUBWF     MD,W       ;
         BTFSC     status,2   ;
         GOTO      RM2        ;
         MOVLW     .3         ;
         SUBWF     MD,W       ;
         BTFSC     status,2   ;
         GOTO      RM3        ;
         MOVLW     .4         ;
         SUBWF     MD,W       ;
         BTFSC     status,2   ;
         GOTO      RM4        ;
         MOVLW     .255       ;
         MOVWF     MD         ;
         GOTO      RM4        ;
RM0      MOVLW     .1         ;2 
         MOVWF     GR         ;
         GOTO      RM5        ;
RM1      MOVLW     .10        ;5 
         MOVWF     GR         ;
         BSF       porta,0    ;
         GOTO      RM5        ;
RM2      MOVLW     .17        ;7 
         MOVWF     GR         ;
         BSF       porta,1    ;
         GOTO      RM5        ;
RM3      MOVLW     .24        ;10  
         MOVWF     GR         ;
         BSF       porta,2    ;
         GOTO      RM5        ;
RM4      MOVLW     .47        ;35 
         MOVWF     GR         ;
         BSF       porta,0    ;
         BSF       porta,1    ;
         BSF       porta,2    ;
         GOTO      RM5        ;
RM5      NOP                  ;
         MOVF      CLKTMR,W   ;
         MOVWF     PQ         ;
RM6      BCF       status,2   ;
         RETURN               ;
; - - - -   10         
PAUSE4   NOP                  ;
         MOVLW     .60        ; 
         MOVWF     TP         ;
CIKL1    MOVLW     .100       ;
         MOVWF     TRV        ;
         DECFSZ    TRV,F      ;
         GOTO      $-1        ;
         DECFSZ    TP,F       ;
         GOTO      CIKL1      ;
PS       NOP                  ; 
         RETURN               ; 
; - - - -
         END                  ;
